//disassembler main routine
//main_disasm.c

#include <stdio.h>
#include <stdlib.h>
#include "testcpu8040.h"
#include "xatremu_caps.h"

using namespace xatremu;

int main(int argc, char **argv){
	if (argc == 1){
		printf("Usage: xatremu_test ipffile\n");
		return 10;
	}
	SDWORD CAPSImgId;

	printf("Size of uint64_t = %d\n", sizeof(uint64_t));

	CAPSInit();
	CAPSImgId = CAPSAddImage();
	SDWORD CAPSLockId;
	printf("Type is %d\n", CAPSGetImageType(argv[1]));
	printf("\n");
	CAPSLockId = CAPSLockImage(CAPSImgId, argv[1]);

	SDWORD CAPSIIRet;
	CapsImageInfo myCAPSImageInfo;
	CAPSIIRet = CAPSGetImageInfo(&myCAPSImageInfo, CAPSImgId);
	printf("Type is again %d\n", myCAPSImageInfo.type);
	printf("Mincyl is %d\n", myCAPSImageInfo.mincylinder);
	printf("Maxcyl is %d\n", myCAPSImageInfo.maxcylinder);
	printf("Minhead is %d\n", myCAPSImageInfo.minhead);
	printf("Maxhead is %d\n", myCAPSImageInfo.maxhead);
	for (int iloop = 0; iloop < CAPS_MAXPLATFORM; ++iloop){
		printf("Platform %d is %d\n", iloop, myCAPSImageInfo.platform[iloop]);
	};
	printf("\n");
	CapsTrackInfo myCAPSTrackInfo, myCAPSTrackInfo2;
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo2, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo2.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	CAPSIIRet = CAPSLockTrack(&myCAPSTrackInfo, CAPSImgId, 0, 0,
		DI_LOCK_INDEX|DI_LOCK_NOISE|DI_LOCK_TRKBIT|DI_LOCK_UPDATEFD);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	printf("Cyl is %d\n", myCAPSTrackInfo.cylinder);
	printf("Head is %d\n", myCAPSTrackInfo.head);
	printf("Sectorcount is %d\n", myCAPSTrackInfo.sectorcnt);
	printf("Sectorsize is %d\n", myCAPSTrackInfo.sectorsize);
	printf("Trackcount is %d\n", myCAPSTrackInfo.trackcnt);
	printf("Tracklen is %d\n", myCAPSTrackInfo.tracklen);
	printf("Track buf PTR is %x\n", myCAPSTrackInfo.trackbuf);
	printf("Track 0 buf PTR is %x\n", myCAPSTrackInfo.trackdata[0]);
	printf("Track 1 buf PTR is %x\n", myCAPSTrackInfo.trackdata[1]);
	printf("Track 2 buf PTR is %x\n", myCAPSTrackInfo.trackdata[2]);
	printf("Track 3 buf PTR is %x\n", myCAPSTrackInfo.trackdata[3]);
	printf("Track 4 buf PTR is %x\n", myCAPSTrackInfo.trackdata[4]);
	printf("Tracklen t2 is %d\n", myCAPSTrackInfo2.tracklen);
	printf("Track t2 buf PTR is %x\n", myCAPSTrackInfo2.trackbuf);


	CAPSUnlockAllTracks(CAPSImgId);
	CAPSUnlockImage(CAPSImgId);
/*	ROMMgmt myROM;
	myROM.LoadData(argv[1]);
	CPU8040 myCPU;
	myCPU.SetInstrMemPtr(myROM.GetDataPtr());
	myCPU.SetROMLen(myROM.GetDataLen());
	myCPU.SetInstrPtr(0);
	while ((myCPU.GetInstrPtr() < myROM.GetDataLen()) && (myCPU.GetInstrPtr() < 0xFFFD)) {
		myCPU.DisAsmNextInstruction();
	};
*/
	CAPSRemImage(CAPSImgId);
	CAPSExit();

	return 0;
};

