//disassembler main routine
//main_disasm.c

#include <stdio.h>
#include <stdlib.h>
#include "rommgmt.h"
#include "cpu8040_disasm.h"

using namespace xatremu;

int main(int argc, char **argv){
	if (argc == 1){
		printf("Usage: disasm8040 xf551_rom\n");
		return 10;
	}
	ROMMgmt myROM;
	if (myROM.LoadData(argv[1]) == 0) return 20;
	CPU8040 myCPU;
	myCPU.SetInstrMemPtr(myROM.GetDataPtr());
	myCPU.SetROMLen(myROM.GetDataLen());
	myCPU.SetInstrPtr(0);
	while ((myCPU.GetInstrPtr() < myROM.GetDataLen()) && (myCPU.GetInstrPtr() < 0xFFFD)) {
		myCPU.DisAsmNextInstruction();
	};

	return 0;
};

