// test of CPU8040 class

#include <stdio.h>
#include <typeinfo>
#include "testcpu8040.h"
#include "testdefines.h"

#define THISOBJECTSNAME "testCPU8040"

namespace xatremu
{
testCPU8040::testCPU8040(){
	char dummystr[6] = "dummy";
	m_ROMMgmtMock.LoadData(dummystr);
	m_CPU8040.SetInstrMemPtr(m_ROMMgmtMock.GetDataPtr());
	m_CPU8040.SetROMLen(m_ROMMgmtMock.GetDataLen());
	m_CPU8040.SetWD1772(&m_WD1772Mock);
	m_CPU8040.SetSerial(&m_SerialMock);
	m_CPU8040.ResetCPU();
};

testCPU8040::~testCPU8040(){
};

void testCPU8040::runTest(){
	testGetInstrMem();
	testSetInstrMem();
	test1_I_ADD_A_AT_R0();
	test2_I_ADD_A_AT_R0();
        test1_I_ADD_A_AT_R1();
        test2_I_ADD_A_AT_R1();
        test1_I_ADD_A_IMM();
        test2_I_ADD_A_IMM();
        test1_I_ADD_A_R0();
        test2_I_ADD_A_R0();
        test1_I_ADD_A_R1();
        test2_I_ADD_A_R1();
        test1_I_ADD_A_R2();
        test2_I_ADD_A_R2();
        test1_I_ADD_A_R3();
        test2_I_ADD_A_R3();
        test1_I_ADD_A_R4();
        test2_I_ADD_A_R4();
        test1_I_ADD_A_R5();
        test2_I_ADD_A_R5();
        test1_I_ADD_A_R6();
        test2_I_ADD_A_R6();
        test1_I_ADD_A_R7();
        test2_I_ADD_A_R7();
	test1_I_ADDC_A_AT_R0();
	test2_I_ADDC_A_AT_R0();
	test3_I_ADDC_A_AT_R0();
	test4_I_ADDC_A_AT_R0();
	test1_I_ADDC_A_AT_R1();
	test2_I_ADDC_A_AT_R1();
	test3_I_ADDC_A_AT_R1();
	test4_I_ADDC_A_AT_R1();
	test1_I_ADDC_A_IMM();
	test2_I_ADDC_A_IMM();
	test3_I_ADDC_A_IMM();
	test4_I_ADDC_A_IMM();
	test1_I_ADDC_A_R0();
	test2_I_ADDC_A_R0();
	test3_I_ADDC_A_R0();
	test4_I_ADDC_A_R0();
	test1_I_ADDC_A_R1();
	test2_I_ADDC_A_R1();
	test3_I_ADDC_A_R1();
	test4_I_ADDC_A_R1();
	test1_I_ADDC_A_R2();
	test2_I_ADDC_A_R2();
	test3_I_ADDC_A_R2();
	test4_I_ADDC_A_R2();
	test1_I_ADDC_A_R3();
	test2_I_ADDC_A_R3();
	test3_I_ADDC_A_R3();
	test4_I_ADDC_A_R3();
	test1_I_ADDC_A_R4();
	test2_I_ADDC_A_R4();
	test3_I_ADDC_A_R4();
	test4_I_ADDC_A_R4();
	test1_I_ADDC_A_R5();
	test2_I_ADDC_A_R5();
	test3_I_ADDC_A_R5();
	test4_I_ADDC_A_R5();
	test1_I_ADDC_A_R6();
	test2_I_ADDC_A_R6();
	test3_I_ADDC_A_R6();
	test4_I_ADDC_A_R6();
	test1_I_ADDC_A_R7();
	test2_I_ADDC_A_R7();
	test3_I_ADDC_A_R7();
	test4_I_ADDC_A_R7();
	test1_I_ANL_A_AT_R0();
	test1_I_ANL_A_AT_R1();
	test1_I_ANL_A_IMM();
	test1_I_ANL_A_R0();
	test1_I_ANL_A_R1();
	test1_I_ANL_A_R2();
	test1_I_ANL_A_R3();
	test1_I_ANL_A_R4();
	test1_I_ANL_A_R5();
	test1_I_ANL_A_R6();
	test1_I_ANL_A_R7();
	//ANL BUS,data omitted (unused) 
	test1_I_ANL_P1_IMM();
	test1_I_ANL_P2_IMM();
	//ANLD Px,A omitted (unused)
	test1_I_CALL();
	test2_I_CALL();
	test1_I_CLR_A();
	test1_I_CLR_C();
	test1_I_CLR_F0();
	test1_I_CLR_F1();
	test1_I_CPL_A();
	test1_I_CPL_C();
	test1_I_CPL_F0();
	test1_I_CPL_F1();
	//DA A omitted (unused)
	test1_I_DEC_A();
	test1_I_DEC_R0();
	test1_I_DEC_R1();
	test1_I_DEC_R2();
	test1_I_DEC_R3();
	test1_I_DEC_R4();
	test1_I_DEC_R5();
	test1_I_DEC_R6();
	test1_I_DEC_R7();
	test1_I_DIS_I();
	test1_I_DIS_TCNTI();
	test1_I_DJNZ_R0_CODE();
	test2_I_DJNZ_R0_CODE();
	test1_I_DJNZ_R1_CODE();
	test2_I_DJNZ_R1_CODE();
	test1_I_DJNZ_R2_CODE();
	test2_I_DJNZ_R2_CODE();
	test1_I_DJNZ_R3_CODE();
	test2_I_DJNZ_R3_CODE();
	test1_I_DJNZ_R4_CODE();
	test2_I_DJNZ_R4_CODE();
	test1_I_DJNZ_R5_CODE();
	test2_I_DJNZ_R5_CODE();
	test1_I_DJNZ_R6_CODE();
	test2_I_DJNZ_R6_CODE();
	test1_I_DJNZ_R7_CODE();
	test2_I_DJNZ_R7_CODE();
	test1_I_EN_I();
	test1_I_EN_TCNTI();
	//ENT0 CLK omitted (unused)
	test1_I_IN_A_P1();
	test1_I_IN_A_P2();
	test1_I_INC_A();
	test1_I_INC_AT_R0();
	test1_I_INC_AT_R1();
	test1_I_INC_R0();
	test1_I_INC_R1();
	test1_I_INC_R2();
	test1_I_INC_R3();
	test1_I_INC_R4();
	test1_I_INC_R5();
	test1_I_INC_R6();
	test1_I_INC_R7();
	//INS A,BUS omitted (unused)
	test1_I_JB0_CODE();
	test2_I_JB0_CODE();
	test1_I_JB1_CODE();
	test2_I_JB1_CODE();
	test1_I_JB2_CODE();
	test2_I_JB2_CODE();
	test1_I_JB3_CODE();
	test2_I_JB3_CODE();
	test1_I_JB4_CODE();
	test2_I_JB4_CODE();
	test1_I_JB5_CODE();
	test2_I_JB5_CODE();
	test1_I_JB6_CODE();
	test2_I_JB6_CODE();
	test1_I_JB7_CODE();
	test2_I_JB7_CODE();
	test1_I_JC_CODE();
	test2_I_JC_CODE();
	test1_I_JF0_CODE();
	test2_I_JF0_CODE();
	test1_I_JF1_CODE();
	test2_I_JF1_CODE();
	test1_I_JMP_CODE();
	test2_I_JMP_CODE();
	test1_I_JMPP_AT_A();
	test1_I_JNC_CODE();
	test2_I_JNC_CODE();
	test1_I_JNI_CODE();
	test1_I_JNT0_CODE();
	test1_I_JNT1_CODE();
	test1_I_JNZ_CODE();
	test2_I_JNZ_CODE();
	test1_I_JT0_CODE();
	test1_I_JT1_CODE();
	test1_I_JTF_CODE();
	test2_I_JTF_CODE();
	test1_I_JZ_CODE();
	test2_I_JZ_CODE();
	test1_I_MOV_A_IMM();
	test1_I_MOV_A_AT_R0();
	test1_I_MOV_A_AT_R1();
	test1_I_MOV_A_PSW();
	test1_I_MOV_A_R0();
	test1_I_MOV_A_R1();
	test1_I_MOV_A_R2();
	test1_I_MOV_A_R3();
	test1_I_MOV_A_R4();
	test1_I_MOV_A_R5();
	test1_I_MOV_A_R6();
	test1_I_MOV_A_R7();
	test1_I_MOV_A_T();
	test1_I_MOV_AT_R0_A();
	test1_I_MOV_AT_R1_A();
	test1_I_MOV_AT_R0_IMM();
	test1_I_MOV_AT_R1_IMM();
	test1_I_MOV_PSW_A();
	test2_I_MOV_PSW_A();
	test1_I_MOV_R0_A();
	test1_I_MOV_R1_A();
	test1_I_MOV_R2_A();
	test1_I_MOV_R3_A();
	test1_I_MOV_R4_A();
	test1_I_MOV_R5_A();
	test1_I_MOV_R6_A();
	test1_I_MOV_R7_A();
	test1_I_MOV_R0_IMM();
	test1_I_MOV_R1_IMM();
	test1_I_MOV_R2_IMM();
	test1_I_MOV_R3_IMM();
	test1_I_MOV_R4_IMM();
	test1_I_MOV_R5_IMM();
	test1_I_MOV_R6_IMM();
	test1_I_MOV_R7_IMM();
	test1_I_MOV_T_A();
	//MOVD A,Px omitted (unused)
	//MOVD Px,A omitted (unused)
	test1_I_MOVP_A_AT_A();
	test1_I_MOVP3_A_AT_A();
	test1_I_MOVX_A_AT_R0();
	test1_I_MOVX_A_AT_R1();
	test1_I_MOVX_AT_R0_A();
	test1_I_MOVX_AT_R1_A();
	test1_I_NOP();
	test1_I_ORL_A_AT_R0();
	test1_I_ORL_A_AT_R1();
	test1_I_ORL_A_IMM();
	test1_I_ORL_A_R0();
	test1_I_ORL_A_R1();
	test1_I_ORL_A_R2();
	test1_I_ORL_A_R3();
	test1_I_ORL_A_R4();
	test1_I_ORL_A_R5();
	test1_I_ORL_A_R6();
	test1_I_ORL_A_R7();
	//ORL BUS,data omitted (unused)
	test1_I_ORL_P1_IMM();
	test1_I_ORL_P2_IMM();
	//ORLD Px,A omitted (unused)
	//OUTL BUS,A omitted (unused)
	test1_I_OUTL_P1_A();
	test1_I_OUTL_P2_A();
	test1_I_RET();
	test1_I_RETR();
	test1_I_RL_A();
	test1_I_RLC_A();
	test2_I_RLC_A();
	test1_I_RR_A();
	test1_I_RRC_A();
	test2_I_RRC_A();
	test1_I_SEL_MB0();
	test1_I_SEL_MB1();
	test1_I_SEL_RB0();
	//SEL RB1 omitted (unused)
	test1_I_STOP_TCNT();
	//STRT CNT omitted (unused)
	test1_I_STRT_T();
	test1_I_SWAP_A();
	test1_I_XCH_A_AT_R0();
	test1_I_XCH_A_AT_R1();
	test1_I_XCH_A_R0();
	test1_I_XCH_A_R1();
	test1_I_XCH_A_R2();
	test1_I_XCH_A_R3();
	test1_I_XCH_A_R4();
	test1_I_XCH_A_R5();
	test1_I_XCH_A_R6();
	test1_I_XCH_A_R7();
	//XCHD a,@Rx omitted (unused)
	test1_I_XRL_A_AT_R0();
	test1_I_XRL_A_AT_R1();
	test1_I_XRL_A_IMM();
	test1_I_XRL_A_R0();
	test1_I_XRL_A_R1();
	test1_I_XRL_A_R2();
	test1_I_XRL_A_R3();
	test1_I_XRL_A_R4();
	test1_I_XRL_A_R5();
	test1_I_XRL_A_R6();
	test1_I_XRL_A_R7();

};

void testCPU8040::testGetInstrMem(){
	TESTOK(*( (char *) m_CPU8040.m_instrMemPtr + 1) == m_CPU8040.GetInstrMem(1), THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::testSetInstrMem(){
	m_CPU8040.SetInstrMem(0x820, 200);
        TESTOK(200 == m_CPU8040.GetInstrMem(0x820), THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_AT_R0(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x60);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 1;
	m_CPU8040.r_R0 = 0x80;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x81;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x82 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x60);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x82;
        m_CPU8040.r_R0 = 0x80;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x4 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x61);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 3;
        m_CPU8040.r_R1 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x83;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x86 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x61);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x84;
        m_CPU8040.r_R1 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x08 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x03);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x85);
        m_CPU8040.m_totalCycles = 7;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x5;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x8a == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_IMM(){
        m_CPU8040.r_PC = 2;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x03);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x86);
        m_CPU8040.m_totalCycles = 7;
        m_CPU8040.r_C = false; 
        m_CPU8040.r_A = 0x87;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x04 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_ADD_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x68);
        m_CPU8040.m_totalCycles = 6;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x21;
	m_CPU8040.r_R0 = 0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa3 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(7 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test2_I_ADD_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x68);
        m_CPU8040.m_totalCycles = 6;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x22;
        m_CPU8040.r_R0 = 0xe3;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x05 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(7 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R1(){
        m_CPU8040.r_PC = 0xa;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x69);
        m_CPU8040.m_totalCycles = 0x14;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x23;
        m_CPU8040.r_R1 = 0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa7 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0b == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x15 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R1(){
        m_CPU8040.r_PC = 0xa;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x69);
        m_CPU8040.m_totalCycles = 0x14;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x24;
        m_CPU8040.r_R1 = 0xe5;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x09 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0b == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x15 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R2(){
        m_CPU8040.r_PC = 0xd;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6a);
        m_CPU8040.m_totalCycles = 0x18;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x25;
        m_CPU8040.r_R2 = 0x86;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xab == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x19 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R2(){
        m_CPU8040.r_PC = 0xd;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6a);
        m_CPU8040.m_totalCycles = 0x18;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x26;
        m_CPU8040.r_R2 = 0xe7;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x19 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R3(){
        m_CPU8040.r_PC = 0xf;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6b);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x27;
        m_CPU8040.r_R3 = 0x88;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xaf == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R3(){
        m_CPU8040.r_PC = 0xf;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6b);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x28;
        m_CPU8040.r_R3 = 0xe9;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x11 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R4(){
        m_CPU8040.r_PC = 0x11;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6c);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x29;
        m_CPU8040.r_R4 = 0x8a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xb3 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x12 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R4(){
        m_CPU8040.r_PC = 0x12;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6c);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x2a;
        m_CPU8040.r_R4 = 0xeb;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x15 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x13 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R5(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6d);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = true; 
        m_CPU8040.r_A = 0x2b;
        m_CPU8040.r_R5 = 0x8c;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xb7 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test2_I_ADD_A_R5(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6d);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x2c;
        m_CPU8040.r_R5 = 0xed;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_ADD_A_R6(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6e);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x2d;
        m_CPU8040.r_R6 = 0x8e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xbb == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R6(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6e);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x2e;
        m_CPU8040.r_R6 = 0xef;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x1d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADD_A_R7(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6f);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x2f;
        m_CPU8040.r_R7 = 0x90;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xbf == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADD_A_R7(){
        m_CPU8040.r_PC = 0x16;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x6f);
        m_CPU8040.m_totalCycles = 0x1c;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R7 = 0xf1;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x17 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x1d == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_AT_R0(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x70);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 4;
	m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x8a;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x8e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x70);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x85;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x8b;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x70);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 6;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x8c;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x93 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x70);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x87;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x8d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x15 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_AT_R1(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x71);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 8;
	m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x8e;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x96 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x71);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x89;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x8f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x18 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x71);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x0a;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x90;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x9b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x71);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x8b;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x91;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x1d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_IMM(){
	m_CPU8040.r_PC = 0x08;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x13);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x92);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x0c;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x9e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x13);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x93);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x8d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x20 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x13);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x94);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x0e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa3 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x13);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x95);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x8f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x25 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R0(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x78);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x40;
	m_CPU8040.r_R0 = 0x50;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x90 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x78);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R0 = 0xff;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x78);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x3e;
        m_CPU8040.r_R0 = 0x4e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x8d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x78);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x3d;
        m_CPU8040.r_R0 = 0xfd;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R1(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x79);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x3c;
	m_CPU8040.r_R1 = 0x4c;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x88 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x79);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x3b;
        m_CPU8040.r_R1 = 0xfb;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x36 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x79);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x3a;
        m_CPU8040.r_R1 = 0x4a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x85 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x79);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x39;
        m_CPU8040.r_R1 = 0xf9;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x33 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R2(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7a);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x38;
	m_CPU8040.r_R2 = 0x48;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x80 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x37;
        m_CPU8040.r_R2 = 0xf7;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x36;
        m_CPU8040.r_R2 = 0x46;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x7d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x35;
        m_CPU8040.r_R2 = 0xf5;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R3(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7b);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x34;
	m_CPU8040.r_R3 = 0x44;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x78 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x33;
        m_CPU8040.r_R3 = 0xf3;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x26 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x32;
        m_CPU8040.r_R3 = 0x42;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x75 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x31;
        m_CPU8040.r_R3 = 0xf1;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R4(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7c);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x30;
	m_CPU8040.r_R4 = 0x40;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x70 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x2f;
        m_CPU8040.r_R4 = 0xef;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x1e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x2e;
        m_CPU8040.r_R4 = 0x3e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x6d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x2d;
        m_CPU8040.r_R4 = 0xed;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x1b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R5(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7d);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x2c;
	m_CPU8040.r_R5 = 0x3c;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x68 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x2b;
        m_CPU8040.r_R5 = 0xeb;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x16 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x2a;
        m_CPU8040.r_R5 = 0x3a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x65 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x29;
        m_CPU8040.r_R5 = 0xe9;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x13 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R6(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7e);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x28;
	m_CPU8040.r_R6 = 0x38;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x60 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x27;
        m_CPU8040.r_R6 = 0xe7;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x26;
        m_CPU8040.r_R6 = 0x36;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x5d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x25;
        m_CPU8040.r_R6 = 0xe5;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ADDC_A_R7(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7f);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_C = false;
	m_CPU8040.r_A = 0x24;
	m_CPU8040.r_R7 = 0x34;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x58 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_ADDC_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.r_A = 0x23;
        m_CPU8040.r_R7 = 0xe3;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x06 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test3_I_ADDC_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x22;
        m_CPU8040.r_R7 = 0x32;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x55 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test4_I_ADDC_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x7f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.r_A = 0x21;
        m_CPU8040.r_R7 = 0xe1;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x03 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_AT_R0(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x50);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0x61;
	m_CPU8040.r_R0 = 0x31;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0xc1;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x41 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x51);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x61;
        m_CPU8040.r_R1 = 0x33;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x31;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_IMM(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x53);
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x91);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0xc1;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x81 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R0(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x58);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0x3f;
	m_CPU8040.r_R0 = 0x81;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x01 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R1(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x59);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0x3f;
	m_CPU8040.r_R1 = 0x82;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x02 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R2(){
	m_CPU8040.r_PC = 8;
	m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5a);
	m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0x3f;
	m_CPU8040.r_R2 = 0x83;
	m_CPU8040.ExecuteInstruction();
        TESTOK(0x03 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R3 = 0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x04 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R4 = 0x85;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x05 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R5 = 0x86;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x06 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R6 = 0x87;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x07 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x5f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.r_R7 = 0x88;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x08 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_P1_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x99);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x01);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port1 = 0x7f;
	m_WD1772Mock.m_MasterResetOccurred = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x01 == m_CPU8040.r_Port1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_WD1772Mock.m_MasterResetOccurred, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ANL_P2_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x9a);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x02);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port2 = 0x7f;
	m_CPU8040.m_DriveNumber = 3; 
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xc2 == m_CPU8040.r_Port2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CALL(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x34);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x02);
	m_CPU8040.r_sp = 0;
	m_CPU8040.m_internalStack[m_CPU8040.r_sp] = 0xff;
	m_CPU8040.m_internalStack[m_CPU8040.r_sp + 1] = 0xff;
        m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_dbf = 0;
	m_CPU8040.r_C = true;
	m_CPU8040.r_F0 = false;
	//m_CPU8040.r_psw = 0x88;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0a == m_CPU8040.m_internalStack[0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x80 == m_CPU8040.m_internalStack[1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x102 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x02 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};
        
void testCPU8040::test2_I_CALL(){
        m_CPU8040.r_PC = 0xa08;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x54);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x0e);
        m_CPU8040.r_sp = 0;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp] = 0xff;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp + 1] = 0xff;
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = 1;
	m_CPU8040.r_C = true;
	m_CPU8040.r_F0 = true;
        //m_CPU8040.r_psw = 0xa8;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x0a == m_CPU8040.m_internalStack[0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xaa == m_CPU8040.m_internalStack[1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa0e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x02 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CLR_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x27);
        m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0xdd;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CLR_C(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x97);
	m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CLR_F0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x85);  
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F0 = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.r_F0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CLR_F1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa5);  
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F1 = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.r_F1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CPL_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x37);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xc2 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CPL_C(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CPL_F0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x95);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F0 = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_F0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_CPL_F1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb5);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F1 = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_F1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x07);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc8);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x3e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3d == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc9);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x3d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3c == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xca);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x3a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x39 == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xcb);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x39;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x38 == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xcc);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x38;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x37 == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xcd);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x36;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x35 == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xce);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x34;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x33 == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DEC_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xcf);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x32;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x31 == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DIS_I(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x15);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_ExternalIntEnabled = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.m_ExternalIntEnabled, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DIS_TCNTI(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x35);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_TCNTIntEnabled = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.m_TCNTIntEnabled, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe8);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x88);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x2f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2e == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x188 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe8);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x88);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe9);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x89);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x2f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2e == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x189 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe9);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x89);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R2_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xea);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x2e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2d == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R2_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xea);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R3_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xeb);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x2d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2c == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18b == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R3_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xeb);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R4_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xec);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x2c;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2b == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18c == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R4_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xec);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R5_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xed);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x2b;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2a == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18d == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R5_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xed);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R6_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xee);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x2a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x29 == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R6_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xee);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_DJNZ_R7_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xef);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x29;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x28 == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x18f == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_DJNZ_R7_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xef);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x8f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x00 == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_EN_I(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x05);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_ExternalIntEnabled = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.m_ExternalIntEnabled, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_EN_TCNTI(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x25);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_TCNTIntEnabled = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.m_TCNTIntEnabled, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_IN_A_P1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x09);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port1 = 0x7f;
	m_CPU8040.r_A = 0xff;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x7b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_IN_A_P2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x0a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port2 = 0x7f;
	m_CPU8040.r_A = 0xff;
	m_CPU8040.m_DriveNumber = 2;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xbf == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x17); 
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x3f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x40 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      
        
void testCPU8040::test1_I_INC_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x10);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x60;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x81;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x82 == m_CPU8040.m_internalRAM[m_CPU8040.r_R0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x11);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x61;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x83 == m_CPU8040.m_internalRAM[m_CPU8040.r_R1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x18);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x20;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x19);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x22;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};


void testCPU8040::test1_I_INC_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x24;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x25 == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x26;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x27 == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x28;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x29 == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x2a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2b == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x2c;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2d == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_INC_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x1f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x2e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2f == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x12);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x98);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x01;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x198 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x12);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x98);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xfe;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x32);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x99);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x02;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x199 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x32);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x99);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xfd;       
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB2_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x52);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x04;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB2_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x52);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xfb; 
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB3_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x72);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x08;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19b == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB3_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x72);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xf7;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB4_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x92);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19c == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB4_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x92);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xef;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB5_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x20;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19d == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB5_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xdf;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB6_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x40;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB6_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0xbf;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JB7_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x80;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19f == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JB7_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf2);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x7f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JC_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x90);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x190 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JC_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x90);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JF0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x91);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F0 = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x191 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JF0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x91);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F0 = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JF1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x76);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x92);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F1 = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x192 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JF1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x76);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x92);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_F1 = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JMP_CODE(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x24);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x02);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = 0;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x102 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test2_I_JMP_CODE(){
        m_CPU8040.r_PC = 0xa08;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x44);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x0e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = 1;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa0e == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_JMPP_AT_A(){
        m_CPU8040.r_PC = 0x208;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb3);
	m_CPU8040.r_A = 0xd;
        m_CPU8040.SetInstrMem(m_CPU8040.r_A, 0x32);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x232 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JNC_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x96);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x196 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JNC_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x96);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_C = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JNI_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x86);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x97);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JNT0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x26);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x98);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JNT1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x46);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x99);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x199 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JNZ_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x96);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x97);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x22;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x197 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JNZ_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x96);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x97);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JT0_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x36);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JT1_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x56);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JTF_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x16);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_TF = true;
        m_CPU8040.ExecuteInstruction();
	TESTOK(false == m_CPU8040.r_TF, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x19c == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JTF_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x16);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x98);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_TF = false;
        m_CPU8040.ExecuteInstruction();
	TESTOK(false == m_CPU8040.r_TF, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_JZ_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x19d == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_JZ_CODE(){
        m_CPU8040.r_PC = 0x108;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc6);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x9d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x23;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x10a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x23);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x20);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x20 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf0);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 4;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x21;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf1);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 4;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x22;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x22 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_PSW(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x10;
	m_CPU8040.r_C = false;
	m_CPU8040.r_F0 = true;
	m_CPU8040.r_sp = 6;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R0(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf8);
        m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_R0 = 0x23;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R1(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf9);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x24;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x24 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R2(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xfa);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x25;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x25 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R3(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xfb);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x26;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x26 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R4(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xfc);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x27;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x27 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R5(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xfd);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x28;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x28 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R6(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xfe);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x29;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x29 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_R7(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xff);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x2a;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2a == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_A_T(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x42);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_T = 0x2b;
        m_CPU8040.r_A = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_AT_R0_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa0);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x2c;
        m_CPU8040.r_R0 = 0x83;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2c == m_CPU8040.m_internalRAM[m_CPU8040.r_R0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_AT_R1_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa1);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x2d;
        m_CPU8040.r_R1 = 0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2d == m_CPU8040.m_internalRAM[m_CPU8040.r_R1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_AT_R0_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb0);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC+1, 0x2e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2e == m_CPU8040.m_internalRAM[m_CPU8040.r_R0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_AT_R1_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb1);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC+1, 0x2f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x85;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2f == m_CPU8040.m_internalRAM[m_CPU8040.r_R1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_PSW_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_F0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x04 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_MOV_PSW_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x24;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_F0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x08 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R0_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa8);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x10;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x30 == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R1_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa9);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x10;
        m_CPU8040.r_A = 0x31;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x31 == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R2_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xaa);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x10;
        m_CPU8040.r_A = 0x32;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x32 == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R3_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xab);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x10;
        m_CPU8040.r_A = 0x33;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x33 == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R4_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xac);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x10;
        m_CPU8040.r_A = 0x34;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x34 == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R5_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xad);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x10;
        m_CPU8040.r_A = 0x35;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x35 == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R6_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xae);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x10;
        m_CPU8040.r_A = 0x36;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x36 == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R7_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xaf);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x10;
        m_CPU8040.r_A = 0x37;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x37 == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R0_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb8);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x38);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R0 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x38 == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R1_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xb9);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x39);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R1 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x39 == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R2_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xba);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R2 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3a == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R3_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xbb);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R3 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3b == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R4_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xbc);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R4 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3c == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R5_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xbd);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R5 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3d == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R6_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xbe);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R6 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3e == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_R7_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xbf);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x3f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_R7 = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x3f == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOV_T_A(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x62);
        m_CPU8040.m_totalCycles = 4;
	m_CPU8040.r_A = 0x40;
        m_CPU8040.r_T = 0x10;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x40 == m_CPU8040.r_T, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVP_A_AT_A(){
        m_CPU8040.r_PC = 0x208;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xa3);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 2, 0x41);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = m_CPU8040.r_PC + 2;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x41 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x209 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVP3_A_AT_A(){
        m_CPU8040.r_PC = 0x208;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe3);
        m_CPU8040.SetInstrMem(0x305, 0x42);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x05;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x42 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x209 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVX_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x80);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 4;
        m_CPU8040.r_R0 = 0x81;
        m_WD1772Mock.m_WD1772Byte=0x43;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x43 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVX_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x81);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 4;
        m_CPU8040.r_R0 = 0x81;
        m_WD1772Mock.m_WD1772Byte=0x44;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x44 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVX_AT_R0_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x90);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x45;
        m_CPU8040.r_R0 = 0x81;
        m_WD1772Mock.m_WD1772Byte=0x43;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x45 == m_WD1772Mock.m_WD1772Byte, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_MOVX_AT_R1_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x91);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x46;
        m_CPU8040.r_R0 = 0x81;
        m_WD1772Mock.m_WD1772Byte=0x43;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x46 == m_WD1772Mock.m_WD1772Byte, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_NOP(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x00);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x40);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 3;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x21;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x41);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 3;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x22;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x43);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x11);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x03;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x13 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      
        
void testCPU8040::test1_I_ORL_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x48);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R0 = 0x11;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x31 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x49);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R1 = 0x12;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x32 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R2 = 0x13;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x33 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R3 = 0x14;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x34 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R4 = 0x15;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x35 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R5 = 0x16;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x36 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R6 = 0x17;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x37 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x4f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x30;
        m_CPU8040.r_R7 = 0x18;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x38 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_ORL_P1_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x89);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x11);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port1 = 0x7e;
        m_WD1772Mock.m_MasterResetOccurred = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x7f == m_CPU8040.r_Port1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_WD1772Mock.m_MasterResetOccurred, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_ORL_P2_IMM(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x8a); 
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x12);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port2 = 0x5d;
	m_CPU8040.m_DriveNumber = 3; 
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xdf == m_CPU8040.r_Port2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x0a == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_OUTL_P1_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x39);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port1 = 0x30;
        m_CPU8040.r_A = 0x21;
        m_WD1772Mock.m_MasterResetOccurred = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_Port1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_WD1772Mock.m_MasterResetOccurred, THISOBJECTSNAME, __FUNCTION__)
};      

void testCPU8040::test1_I_OUTL_P2_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x3a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_Port2 = 0x5d;
	m_CPU8040.r_A = 0x22;
        m_CPU8040.m_DriveNumber = 2; 
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa2 == m_CPU8040.r_Port2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x09 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      
 
void testCPU8040::test1_I_RET(){
        m_CPU8040.r_PC = 0xa08;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x83);
        m_CPU8040.r_sp = 2;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp - 1] = 0x23;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp - 2] = 0x80;
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = 1;
        m_CPU8040.ExecuteInstruction();
        //TESTOK(0x0a == m_CPU8040.m_internalStack[0], THISOBJECTSNAME, __FUNCTION__)
        //TESTOK(0xaa == m_CPU8040.m_internalStack[1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x380 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x00 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_RETR(){
        m_CPU8040.r_PC = 0xa08;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x93);
        m_CPU8040.r_sp = 2;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp - 1] = 0x83;
        m_CPU8040.m_internalStack[m_CPU8040.r_sp - 2] = 0x81;
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = 1;
        m_CPU8040.r_C = false;
        m_CPU8040.r_F0 = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(false == m_CPU8040.r_F0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x381 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x00 == m_CPU8040.r_sp, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_RL_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x05 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_RLC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x82;
	m_CPU8040.r_C = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x04 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
	TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_RLC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf7);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x82;
        m_CPU8040.r_C = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x05 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_RR_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x77);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x81;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xc0 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_RRC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x67);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x41;
        m_CPU8040.r_C = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x20 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test2_I_RRC_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x67);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x41;
        m_CPU8040.r_C = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0xa0 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(true == m_CPU8040.r_C, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_SEL_MB0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xe5);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.r_dbf, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_SEL_MB1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xf5);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_dbf = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.r_dbf, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_SEL_RB0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xc5);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.ExecuteInstruction();
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_STOP_TCNT(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x65);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_TRunning = true;
        m_CPU8040.ExecuteInstruction();
        TESTOK(false == m_CPU8040.m_TRunning, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_STRT_T(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x55);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.m_TRunning = false;
        m_CPU8040.ExecuteInstruction();
        TESTOK(true == m_CPU8040.m_TRunning, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_SWAP_A(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x47);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x31;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x13 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x20);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x21;
        m_CPU8040.r_R0 = 0x81;
	m_CPU8040.m_internalRAM[m_CPU8040.r_R0] = 0x3f;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.m_internalRAM[m_CPU8040.r_R0], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3f == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x21);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x22;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1] = 0x3e;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x22 == m_CPU8040.m_internalRAM[m_CPU8040.r_R1], THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3e == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x28);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x23;
        m_CPU8040.r_R0 = 0x3d;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x23 == m_CPU8040.r_R0, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3d == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x29);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x24;
        m_CPU8040.r_R1 = 0x3c;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x24 == m_CPU8040.r_R1, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3c == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2a);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x25;
        m_CPU8040.r_R2 = 0x3b;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x25 == m_CPU8040.r_R2, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3b == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2b);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x26;
        m_CPU8040.r_R3 = 0x3a;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x26 == m_CPU8040.r_R3, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x3a == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2c);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x27;
        m_CPU8040.r_R4 = 0x39;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x27 == m_CPU8040.r_R4, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x39 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2d);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x28;
        m_CPU8040.r_R5 = 0x38;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x28 == m_CPU8040.r_R5, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x38 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2e);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x29;
        m_CPU8040.r_R6 = 0x37;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x29 == m_CPU8040.r_R6, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x37 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XCH_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0x2f);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x2a;
        m_CPU8040.r_R7 = 0x36;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x2a == m_CPU8040.r_R7, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0x36 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_AT_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd0);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 3;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R0]=0x21;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x22 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};      
        
void testCPU8040::test1_I_XRL_A_AT_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd1);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 3;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.m_internalRAM[m_CPU8040.r_R1]=0x22;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x21 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_IMM(){
        m_CPU8040.r_PC = 0x8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd3);
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC + 1, 0x11);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x03;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x12 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(0xa == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(6 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
}; 

void testCPU8040::test1_I_XRL_A_R0(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd8);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R0 = 0x81;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x11 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R1(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xd9);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R1 = 0x82;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x12 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R2(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xda);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R2 = 0x83;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x13 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R3(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xdb);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R3 = 0x84;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x14 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R4(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xdc);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R4 = 0x85;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x15 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R5(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xdd);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R5 = 0x86;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x16 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R6(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xde);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R6 = 0x87;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x17 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};

void testCPU8040::test1_I_XRL_A_R7(){
        m_CPU8040.r_PC = 8;
        m_CPU8040.SetInstrMem(m_CPU8040.r_PC, 0xdf);
        m_CPU8040.m_totalCycles = 4;
        m_CPU8040.r_A = 0x90;
        m_CPU8040.r_R7 = 0x88;
        m_CPU8040.ExecuteInstruction();
        TESTOK(0x18 == m_CPU8040.r_A, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(9 == m_CPU8040.r_PC, THISOBJECTSNAME, __FUNCTION__)
        TESTOK(5 == m_CPU8040.m_totalCycles, THISOBJECTSNAME, __FUNCTION__)
};





};
